#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "globals.h"
// #include "functions.h"

/* ASP to PHP converter           */
/* Copyright 1999 by Michael Kohn */

/*
Token Types:

0: EOF
1: number
2: keyword
3: _
4: identifier
5: EOL
6: %>
7: +,-,*,/
8: >,<,<=,>=,<>
9: &
10: "    "
11: '    '
12: (,)
13: :
14: .
15: comment
16: ,

*/

/*

DataBase Types:

1: MySQL
2: ODBC
3: Oracle 8

Object Types:

1: ADODB.Connection
2: ADODB.RecordSet
3: ADODB.Command

*/

char tokenpush[255]={ 0 };;
int tokentypepush=0;
FILE *in,*out;
int pushback=-1;
char keywords[80][20]=
  { "atn","case","cos","do","exp","if","else","elseif",
    "end","for","dim","log","randomize","rnd","sin","sqr","tan",
    "request","response","session","select",
    "while","write",0 };
int indent=0,line=1,column=0;
char objects[80][50];
char objectstype[80][50];
int objectsptr=0;
int database_type=0;
int setvar=0;
int add_isnum=0,add_session=0,BOF=0;
int infunct=0,functptr;
char funct[80][50];
char global_uid[70];
char global_passwd[70];
char global_database[70];
char global_address[70];
char global_dsn[70];
char sessionpool[256][200];
int sessionptr=0;
int pngs=0;

/* error() - output error messages */

void error(char *token,char *expected,char *keyword)
{
  printf("Parse Error: Expected '%s' and got '%s' in '%s' on line %d\n",expected,token,keyword,line);
}

/* push() - pushback a token (for looking ahead) */

void push(char *token,int tokentype)
{
  strcpy(tokenpush,token);
  tokentypepush=tokentype;
}

/* isnum() - check and see if current string is a number */

int isnum(char *s)
{
int l,t;

  l=strlen(s);

  for(t=0; t<l; t++)
  { if (s[t]<'0' || s[t]>'9') return 0; }

  return 1;
}

/* strcasestr - case insensitive version of strstr */

char *strcasestr(char *hejstack, char *needle)
{
int hejlen,neelen;
int t;

  hejlen=strlen(hejstack);
  neelen=strlen(needle);

  for(t=0; t<=hejlen-neelen; t++)
  {
    if (strncasecmp(&hejstack[t],needle,neelen)==0)
    { return &hejstack[t]; }
  }

  return (char *)0;
}

/* PHP 3.0 and lower didn't have an isnum type function
   close enough to asp this adds one into the output source
   if needed */

void insert_isnum()
{
  fprintf(out,"\nfunction IsNumeric($n)\n{\n");
  fprintf(out,"  $p=trim($n);\n  $l=strlen($p);\n\n");
  fprintf(out,"  for ($t=0; $t<$l; $t++)\n");
  fprintf(out,"  {\n    $c=substr($p,$t,1);\n");
  fprintf(out,"    if ($c<'0' || $c>'9')\n");
  fprintf(out,"    { if ($c!='.') return 0; }\n");
  fprintf(out,"  }\n\n  return 1;\n}\n");

  add_isnum=0;
}

/* getobject() - figure out what kind of object the
   next token is and place it in the literal pool */

int getobject(char *token)
{
int t;

  for (t=0; t<objectsptr; t++)
  { if (strcasecmp(token,objects[t])==0) break; }

  if (t==objectsptr) return 0;

  if (strcasestr(objectstype[t],"ADODB.Connection")!=0) return 1;
  if (strcasestr(objectstype[t],"ADODB.Execute")!=0) return 2;
  if (strcasestr(objectstype[t],"ADODB.Command")!=0) return 3;
  if (strcasestr(objectstype[t],"ADODB.RecordSet")!=0) return 2;

  return 0;
}

/* autoindent() - this sets up proper clean Kohnian style
   programming indenting in the outputted php code */

int autoindent()
{
int r;
char spaces[1024];

  /* if (column!=0) return 0; */
  strcpy(spaces,"");

  for (r=0; r<indent; r++)
  { strcat(spaces,"  "); }

  fprintf(out,"%s",spaces);

  return 0;
}

/* fixw2k changes occurances of .asp to .php3 and
   .htm to .html */

fixw2k(char *token)
{
int l,sl,t;

  sl=strlen(token)-4;

  for (l=1; l<sl; l++)
  {
    if (token[l]=='.')
    {
      if ((token[l+1]=='a' || token[l+1]=='A') &&
         ((token[l+2]=='s' || token[l+2]=='S') &&
         (token[l+3]=='p' || token[l+3]=='P')))
      {
	if (!((token[l+4]>='a' && token[l+4]<='z') ||
	(token[l+4]>='A' && token[l+4]<='Z')))
        {
          token[l+1]='p';
          token[l+2]='h';
          token[l+3]='p';
          for (t=sl+4; t>l+3; t--)
          { token[t+1]=token[t]; }
          token[l+4]='3';
	  sl++;
        }
      }
	else
      if ((token[l+1]=='h' || token[l+1]=='H') &&
         ((token[l+2]=='t' || token[l+2]=='T') &&
         (token[l+3]=='m' || token[l+3]=='M')))
      {
	if (!((token[l+4]>='a' && token[l+4]<='z') ||
	(token[l+4]>='A' && token[l+4]<='Z')))
        {
/*
          token[l+1]='h';
          token[l+2]='t';
          token[l+3]='m';
*/
          for (t=sl+4; t>l+3; t--)
          { token[t+1]=token[t]; }
          token[l+4]='l';
          sl++;
        }
      }
    }
  }
}

/* checks to see if the current token is a known
   defined function */

int isfunction(char *token)
{
int t=0;

  while(funct[t][0]!=0)
  {
    if (strcasecmp(funct[t],token)==0) return 1;
    t++;
  }

  return 0;
}

/* iskeyword() - I believe this is obsolete.  I was going
   to make asp2php test to see if tokens were known keywords
   before trying to use them */

int iskeyword(char *token)
{
int t=0;

  while(keywords[t][0]!=0)
  {
    if (strcasecmp(keywords[t],token)==0) return 1;
    t++;
  }

  return 0;
}

/* eval_keyword() - Could be removed if a small piece
   of code is changed.  I'll do it later. */

int eval_keyword(char *token)
{
  printf("not implemented yet\n");
}

/* parse_request() - Request.* object */

int parse_request(char *newtoken)
{
int tokentype;
char token[TOKENSIZE];
char temp[512]={0};
char temp2[512]={0};

  if ((tokentype=gettoken(token))!=14)
  {
    if (strcmp(token,"(")==0)
    {
      push(token,tokentype);

      eval_funct(temp);
      sprintf(temp2,"(empty($HTTP_GET_VARS[%s]) ? $HTTP_POST_VARS[%s] : $HTTP_GET_VARS[%s])",temp,temp,temp);
      strcat(newtoken,temp2);
    }
      else
    { error(token,".","parse_request"); }

    return;
  }

  tokentype=gettoken(token);

  if (strcasecmp(token,"form")==0)
  { 
    tokentype=gettoken(token);
    if (strcmp(token,".")==0)
    {
      tokentype=gettoken(token);
      if (strcasecmp(token,"count")==0)
      { strcat(newtoken,"count($HTTP_POST_VARS)"); }
    }
      else
    {
      push(token,tokentype);
      strcat(newtoken,"$HTTP_POST_VARS[");
      eval_funct(newtoken);
      strcat(newtoken,"]");
    }
  } 
    else
  if (strcasecmp(token,"querystring")==0)
  { 
    tokentype=gettoken(token);
    if (strcmp(token,".")==0)
    {
      tokentype=gettoken(token);
      if (strcasecmp(token,"count")==0)
      { strcat(newtoken,"count($HTTP_GET_VARS)"); }
    }
      else
    {
      push(token,tokentype);
      strcat(newtoken,"$HTTP_GET_VARS[");
      eval_funct(newtoken);
      strcat(newtoken,"]");
    }
  } 
    else
  if (strcasecmp(token,"cookies")==0)
  { 
    tokentype=gettoken(token);
    if (strcmp(token,".")==0)
    {
      tokentype=gettoken(token);
      if (strcasecmp(token,"count")==0)
      { strcat(newtoken,"count($HTTP_COOKIE_VARS)"); }
    }
      else
    {
      push(token,tokentype);
      strcat(newtoken,"$HTTP_COOKIE_VARS[");
      eval_funct(newtoken);
      strcat(newtoken,"]");
    }
  } 
    else
  if (strcasecmp(token,"servervariables")==0)
  { 
    strcat(newtoken,"${");
    eval_funct(newtoken);
    strcat(newtoken,"}");
  } 
    else
  { strcat(newtoken,"// asp2php says 'huh'?: "); eval_expression(" "); }
}


int parse_command_set(char *newtoken,char *variable)
{
int tokentype;
char token[TOKENSIZE];

  tokentype=gettoken(token);
  strcpy(newtoken,"");

  if (tokentype==2)
  {
    autoindent();
    fprintf(out,"$%s_%s=",variable,token);

    tokentype=gettoken(token);

    if (strcmp(token,"=")!=0)
    { error(token,"=","Command Object"); }
    eval_expression(" ");
  }
}

int parse_command(char *newtoken,char *variable)
{
int tokentype;
char token[TOKENSIZE];
char temp[1024];

  sprintf(newtoken,"%s",variable);

  while(1)
  {
    tokentype=gettoken(token);

    if (tokentype!=2)
    { push(token,tokentype); break; }

    sprintf(temp,"_%s",token);

    tokentype=gettoken(token);

    if (strcmp(token,".")!=0)
    { push(token,tokentype); break; }
  }
}

int eval_funct(char *newtoken)
{
int tokentype;
char token[TOKENSIZE];
int parencount=1;
char molecule[LINELENGTH];

  tokentype=gettoken(token);
  if (strcmp("(",token)!=0)
  { error(token,"(","eval_funct"); return; }

  while((tokentype=gettoken(token))!=0)
  {
    if (strcmp("(",token)==0)
    { parencount++; strcat(newtoken,"("); }
      else
    if (strcmp(")",token)==0)
    { 
      parencount--;
      if (parencount!=0) 
      { strcat(newtoken,")"); }
	else
      { break; }
    }
      else
    if (strcmp(",",token)==0)
    { strcat(newtoken,","); }
      else
    { 
      eval_element(molecule,tokentype,token);
      strcat(newtoken,molecule);
    }
  }
}

int parse_server(char *newtoken)
{
int tokentype;
char token[TOKENSIZE];
char temptoken[LINELENGTH];

  if ((tokentype=gettoken(token))!=14)
  {
    error(token,".","Server");
    return;
  }

  tokentype=gettoken(token);

  if (strcasecmp(token,"htmlencode")==0)
  { 
    strcat(newtoken,"htmlspecialchars("); 
    eval_funct(newtoken); 
    strcat(newtoken,")");
  } 
    else
  if (strcasecmp(token,"urlencode")==0)
  { 
    strcat(newtoken,"rawurlencode("); 
    eval_funct(newtoken); 
    strcat(newtoken,")");
  } 
    else
  if (strcasecmp(token,"scripttimeout")==0)
  {
    tokentype=gettoken(token);
    if (strcmp(token,"=")!=0)
    { error(token,"=","ScriptTimeOut"); }
    strcat(newtoken,"set_time_limit(");
    eval_molecule(temptoken);
    strcat(newtoken,temptoken);
    strcat(newtoken,");\n");
  } 
    else
  { strcat(newtoken,"// asp2php says 'huh'?: "); eval_expression(" "); }
}

int parse_set(char *newtoken)
{
int tokentype;
char token[TOKENSIZE];
char temptoken[4096];
int t;

  tokentype=gettoken(token);

  for (t=0; t<objectsptr; t++)
  { if (strcasecmp(token,objects[t])==0) break; }

  if (t<objectsptr && getobject(token)==3)
  {
    strcpy(temptoken,token);

    tokentype=gettoken(token);
    if (strcmp(token,".")==0)
    {
      tokentype=gettoken(token);
      sprintf(newtoken,"$%s_%s=",temptoken,token);

      tokentype=gettoken(token);
      if (strcmp(token,"=")!=0)
      { error(token,"=","Set"); }

      tokentype=gettoken(token);
      if (getobject(token)==1)
      {
        strcat(newtoken,"$");
        strcat(newtoken,token);
      }

      while(tokentype!=5)
      { tokentype=gettoken(token); }

      strcat(newtoken,";");
      strcat(newtoken,"\n");

      return;
    }
      else
    { push(token,tokentype); }
  }

  strcpy(objects[t],token);
  strcpy(objectstype[t],"unkown");
  if (t==objectsptr) objectsptr++;

  tokentype=gettoken(token);
  if (strcmp(token,"=")!=0)
  { error(token,"=","Set"); }

  tokentype=gettoken(token);
  if (strcasecmp(token,"server")==0)
  {
    tokentype=gettoken(token);
    if (strcmp(token,".")!=0)
    { error(token,".","Server"); }

    tokentype=gettoken(token);
    if (strcasecmp(token,"createobject")==0)
    {
      tokentype=gettoken(token);
      if (strcmp(token,"(")!=0)
      { error(token,"(","CreateObject"); }

      tokentype=gettoken(token);
      if (tokentype!=10 && tokentype!=11)
      { error(token,"String Literal","CreateObject"); }

      strcpy(objectstype[t],token);
      if (t==objectsptr) objectsptr++;

      tokentype=gettoken(token);
      if (strcmp(token,")")!=0)
      { error(token,")","CreateObject"); }
      sprintf(newtoken,"// $%s is of type %s\n",objects[t],objectstype[t]);
    }
      else
    {
      setvar=t;
      eval_element(newtoken,tokentype,token);
      setvar=0;
      sprintf(newtoken,"// $%s is of type %s\n",objects[t],objectstype[t]);
    } 
    
  }
    else
  {
/* printf("Set NOT SERVER (eval_element): %s\n",token); */
    setvar=t;
    eval_element(newtoken,tokentype,token);
/* printf("came back: %s\n",newtoken); */
    setvar=0;
/*
    strcpy(tokenpush,token);
    tokentypepush=tokentype;
    eval_molecule(temptoken);
    sprintf(newtoken,"$%s=",objects[t]);
    strcat(newtoken,temptoken);
*/
  }
}

int eval_expression(char *oldtoken)
{
int tokentype;
char token[TOKENSIZE];
char temp[TOKENSIZE];
char newtoken[LINELENGTH];
int isstring=0;
int r;

  if (oldtoken[0]!=' ')
  { 
    autoindent();
    fprintf(out,"$%s",oldtoken);

    tokentypepush=gettoken(temp);
    strcpy(tokenpush,temp);

    if (strcmp(temp,"(")==0)
    {
      newtoken[0]=0;
      eval_funct(newtoken);
      fprintf(out,"[%s]",newtoken);
      newtoken[0]=0;
    }
  }

  while((tokentype=gettoken(token))!=5 && tokentype!=13)
  {
    if (tokentype==10 || tokentype==11)
    { isstring=1; }

    if (tokentype==0) { return; }
      else
    if (tokentype==15)
    { fprintf(out,"; %s",token); }
      else
    if (tokentype==6)
    {
      fprintf(out,"; ");
      strcpy(tokenpush,token);
      tokentypepush=tokentype;
      return;
    }
      else
    if (strcasecmp(token,"mod")==0)
    { fprintf(out,"%c",'%'); }
      else
    if (strcmp(token,"+")==0 && isstring==1)
    { fprintf(out,"."); }
      else
    if (strcmp(token,",")==0)
    { 
      strcpy(tokenpush,token);
      tokentypepush=tokentype;
      return;
    }
      else
    if (tokentype==3)
    {
      fprintf(out,"\n  ");
      autoindent();
      continue;
    }
      else
    {
      r=eval_element(newtoken,tokentype,token);
      fprintf(out,newtoken);
      if (r==-1) return;
    }
  }

  putc(';',out);
  if (tokentype==5) putc('\n',out);
    else
  if (tokentype==13) fprintf(out," ");

}

int parse_response()
{
int tokentype;
char token[TOKENSIZE];
char newtoken[LINELENGTH];

  autoindent();

  if ((tokentype=gettoken(token))!=14)
  {
    error(token,".","Response");
    return;
  }

  tokentype=gettoken(token);

  if (strcasecmp(token,"write")==0)
  {
    fprintf(out,"echo ");
    tokentype=gettoken(token);
    strcpy(tokenpush,token);
    tokentypepush=tokentype;
    if (strcmp(token,"(")==0)
    {
      strcpy(newtoken,"");
      eval_funct(newtoken);
      fprintf(out,"%s;",newtoken);
    }
      else
    {
      eval_molecule(newtoken);
      fprintf(out,"%s;\n",newtoken);
    }
  } 
    else
  if (strcasecmp(token,"contenttype")==0)
  {
    tokentype=gettoken(token);
    if (strcmp(token,"=")!=0)
    { error(token,"=","ContentType"); }

    fprintf(out,"header(\"Content-type: \".");
    eval_molecule(newtoken);
    fprintf(out,"%s);\n",newtoken);
  }
    else
  if (strcasecmp(token,"addheader")==0)
  {
    fprintf(out,"header(");
    eval_molecule(newtoken);
    fprintf(out,"%s.\": \".",newtoken);
    eval_molecule(newtoken);
    fprintf(out,"%s);\n",newtoken);
  } 
    else
  if (strcasecmp(token,"redirect")==0)
  {
    fprintf(out,"header(\"Location: \".");
    tokentype=gettoken(token);
    strcpy(tokenpush,token);
    tokentypepush=tokentype;

    if (strcmp(token,"(")==0)
    {
      strcpy(newtoken,"");
      eval_funct(newtoken);
      fprintf(out,"%s);\nexit;\n",newtoken);
    }
      else
    {
      eval_molecule(newtoken);
      fprintf(out,"%s);\nexit;\n",newtoken);
    }
  }
    else
  { fprintf(out,"// asp2php says 'huh'?: "); eval_expression(" "); }
}

int parse_rem()
{
int ch;

  fprintf(out,"// ");

  while(ch=getc(in))
  {
    if (ch=='\r') ch='\n';
    putc(ch,out);
    if (ch=='\n' || ch==EOF) return;
  }
}

int parse_dim()
{
char token[TOKENSIZE];
int tokentype;

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5 || tokentype==13) break;
  }
  return 0;

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==6)
    {
      strcpy(tokenpush,token);
      tokentypepush=tokentype;
      return; 
    }
      else
    if (tokentype==5 || tokentype==13)
    { putc('\n',out); return; }
      else
    if (tokentype!=2 && tokentype!=16)
    { error(token,", or variable","Dim"); }
      else
    if (tokentype==2)
    { fprintf(out,"$%s=0; ",token); }
  } 
}

int parse_at()
{
int tokentype;
char token[TOKENSIZE];

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==6)
    {
      strcpy(tokenpush,token);
      tokentypepush=tokentype;
      return; 
    }
      else
    if (tokentype==5 || tokentype==13)
    { break; }
      else
    if (strcasecmp(token,"language")==0)
    { fprintf(out,"// LANGUAGE = asp2php converted\n"); }
  }
}

int eval_token(int tokentype,char *token)
{
char temptoken[TOKENSIZE];
char newtoken[1024];
int t,ch;

  if (strcasecmp(token,"do")==0)
  { parse_do(); }
    else
  if (strcasecmp(token,"while")==0)
  { parse_while(); }
    else
  if (strcasecmp(token,"select")==0)
  { parse_select(); }
    else
  if (strcasecmp(token,"if")==0)
  { parse_if(); }
    else
  if (strcasecmp(token,"rem")==0)
  { parse_rem(); }
    else
  if (strcasecmp(token,"dim")==0)
  { parse_dim(); }
    else
  if (strcasecmp(token,"option")==0)
  { fprintf(out,"// Option "); eval_expression(" ");  }
    else
  if (tokentype==2 && strcasecmp(token,"set")==0)
  {
    parse_set(newtoken);
    fprintf(out,"%s",newtoken);
  }
    else
  if (strcasecmp(token,"sub")==0)
  { parse_funct(2); }
    else
  if (strcasecmp(token,"function")==0)
  { parse_funct(1); }
    else
  if (strcasecmp(token,"session")==0)
  { parse_session(); }
    else
  if (strcasecmp(token,"response")==0)
  { parse_response(); }
    else
  if (strcasecmp(token,"server")==0)
  {
    parse_server(newtoken);
    fprintf(out,"%s",newtoken);
  }
    else
  if (strcasecmp(token,"for")==0)
  { parse_for(); }
    else
  if (strcmp(token,"@")==0)
  { parse_at(); }
    else
  if (strcmp(token,"=")==0)
  {
    autoindent();
    fprintf(out,"echo ");
    eval_expression(" ");
  }
    else
  if (tokentype==2 && ((t=getobject(token))!=0))
  {
    strcpy(temptoken,token);
    tokentype=gettoken(token);
    if (strcmp(token,".")!=0)
    {
      strcpy(tokenpush,token);
      tokentypepush=tokentype;
    }

    if (t==1) { parse_adodb_connection(newtoken,temptoken); }
      else
    if (t==2) { parse_adodb_rs(newtoken,temptoken); }
      else
    if (t==3) { parse_command_set(newtoken,temptoken); }

    fprintf(out,"%s",newtoken);
  }
    else
  if (tokentype==11)
  {
    /* This kinda sucks but.. if token is 11 at the beginning of the line
    lets assume that it's a comment line.. this might cause problems..
    if you have problems, comment this crap out */
    fprintf(out,"//%s",&token[1]);
    ch=0;
    while (ch!='\r' && ch!='\n')
    {
      if (pushback!=-1)
      { ch=pushback; pushback=-1; }
        else
      { ch=getc(in); }
      if (ch==EOF) break;
      putc(ch,out);
    }
    line++;
    pushback=getc(in);
    if (pushback=='\n' || pushback=='\r')
    { if (ch!=pushback) pushback=-1; }
  }
    else
  { eval_expression(token); }

  return 0;
}

int eval_molecule(char *newtoken)
{
char token[TOKENSIZE];
char temptoken[LINELENGTH];
int tokentype;
int isstring=0;
int r;
int paren=0;

  strcpy(newtoken,"");

  while((tokentype=gettoken(token))!=0)
  {
    if (strcmp(token,"(")==0) paren++;
      else
    if (strcmp(token,")")==0) paren--;

    if (paren<0) return 1;

    if (tokentype==10 || tokentype==11)
    { isstring=1; strcat(newtoken,token); }
      else
    if (tokentype==6)
    {
      tokentypepush=tokentype;
      strcpy(tokenpush,token);
      break;
    }
      else
    if (tokentype==5 || tokentype==13)
    { break; }
      else
    if (strcmp(token,"&")==0)
    { strcat(newtoken,"."); }
      else
    if (strcmp(token,",")==0)
    { break; }
      else
    if (strcmp(token,"+")==0 && isstring==1)
    { strcat(newtoken,"."); }
      else
    if (tokentype==2 && strcasecmp(token,"AND")==0)
    { strcat(newtoken,"&"); }
      else
    if (tokentype==2 && strcasecmp(token,"OR")==0)
    { strcat(newtoken,"|"); }
      else
    if (tokentype==1)
    { strcat(newtoken,token); }
      else
    if (tokentype==3)
    {
      strcat(newtoken,"\n");
      for (r=0; r<indent+1; r++) strcat(newtoken,"  ");
    }
      else
    if (tokentype!=2)
    { strcat(newtoken,token); }
      else
    {
      eval_element(temptoken,tokentype,token);
      strcat(newtoken,temptoken);
    }
  }

  return 0;
}

int parse_body(int iflag)
{
char token[TOKENSIZE];
char newtoken[LINELENGTH];
int tokentype,c,ch;

  while((tokentype=gettoken(token))!=0)
  {
    if (tokentype==5 && iflag==1)
    { break; }
      else
    if (tokentype==5)
    { putc('\n',out);  /* THIS MIGHT SUCK */  }
      else
    if (tokentype==6)
    {
      if (iflag==1)
      {
	tokentypepush=tokentype;
	strcpy(tokenpush,token);
	putc('\n',out);
	return;
      }

      fprintf(out,"?>"); copyhtml();
    }
      else
    if (strcasecmp(token,"case")==0)
    { strcpy(tokenpush,token); tokentypepush=tokentype; break; }
      else
    if ((strcasecmp(token,"loop")==0 || strcasecmp(token,"wend")==0) ||
         (strcasecmp(token,"end")==0 || strcasecmp(token,"next")==0))
    { break; }
      else
    if (strcasecmp(token,"elseif")==0)
    { 
      indent--;
      fprintf(out,"}\n");
      autoindent();
      fprintf(out,"  else\n");
      autoindent();
      fprintf(out,"if ");
      parse_condition();
      fprintf(out,"\n");
      autoindent();
      fprintf(out,"{\n");
      indent++;
    }
      else
    if (strcasecmp(token,"session")==0)
    { parse_session(); }
      else
    if (strcasecmp(token,"else")==0)
    { 
      indent--;
      autoindent();
      fprintf(out,"}\n");
      autoindent();
      fprintf(out,"  else\n");
      autoindent();
      fprintf(out,"{\n");
      indent++;
    }
      else
    if (tokentype==15)
    { fprintf(out,"%s",token); }
      else
    if (tokentype==0)
    { return 0; }
      else
    if (isfunction(token)==1)
    {
      c=gettoken(token);
      if (strcmp(token,"=")==0)
      {
        autoindent();
	fprintf(out,"return ");
	eval_expression(" ");
      }
	else
      if (strcmp(token,"(")==0)
      {
	fprintf(out,"%s(",token);
	strcpy(tokenpush,"(");
	tokentypepush=tokentype;
	eval_funct(newtoken);
	fprintf(out,"%s);",newtoken);
      }
	else
      {
	error(token,"= or (","body");
      }
    }
      else
    if (tokentype==2 || strcmp("=",token)==0) 
    { eval_token(tokentype,token); }
      else
    if (tokentype==11)
    {
      /* This kinda sucks but.. if token is 11 at the beginning of the line
      lets assume that it's a comment line.. this might cause problems..
      if you have problems, comment this crap out */
      fprintf(out,"//%s",&token[1]);
      ch=0;
      while (ch!='\r' && ch!='\n')
      {
        if (pushback!=-1)
        { ch=pushback; pushback=-1; }
          else
        { ch=getc(in); }
        if (ch==EOF) break;
        putc(ch,out);
      }
      line++;
      pushback=getc(in);
      if (pushback=='\n' || pushback=='\r')
      { if (ch!=pushback) pushback=-1; }
    }
   
    if (iflag==1) break;
  }
 
  if (tokentype==5) { putc('\n',out); }
}

int parse_funct(int isfunct)
{
char token[TOKENSIZE];
char newtoken[LINELENGTH];
int tokentype,c;

  infunct=isfunct; 

  tokentype=gettoken(token);
  fprintf(out,"function %s",token);

  tokentype=gettoken(token);
  strcpy(tokenpush,token);
  tokentypepush=tokentype;

  newtoken[0]=0;

  if (strcmp(token,"(")==0)
  { eval_funct(newtoken); fprintf(out,"(%s)",newtoken); }
    else
  { fprintf(out,"()"); }

  fprintf(out,"\n");
  autoindent();
  fprintf(out,"{\n");
  indent++;
  c=parse_body(0);
  indent--;
  autoindent();
  fprintf(out,"} ");

  tokentype=gettoken(token);

  if (isfunct==1)
  {
    if (strcasecmp(token,"function")!=0)
    { error(token,"function","function"); }
  }
    else
  if (isfunct==2)
  {
    if (strcasecmp(token,"sub")!=0)
    { error(token,"sub","Sub"); }
  }
  infunct=0;
}

int parse_do()
{
char token[TOKENSIZE];
int c;

  if ((c=gettoken(token))!=2 || strcasecmp(token,"while")!=0)
  {
    strcpy(tokenpush,token);
    tokentypepush=c;
    parse_do_loop();
    return;
  }

  fprintf(out,"while");
  c=parse_condition();
  fprintf(out,"\n");
  autoindent();
  fprintf(out,"{\n");
  indent++;
  c=parse_body(0);
  indent--;
  autoindent();
  fprintf(out,"} ");
}

int parse()
{
char token[1024];
char lasttoken[1024];
int tokentype;

  copyhtml();

/*
function IsNumeric($n)
{
  $p=trim($n);
  $l=strlen($p);

  for ($t=0; $t<$l; $t++)
  {
    $c=substr($p,$t,1);
    if ($c<'0' || $c>'9')
    { if ($c!='.') return 0; }
  }

  return 1;
}

*/

  while((tokentype=gettoken(token))!=0)
  {
    if (add_isnum==1)
    { insert_isnum(); }

    if (tokentype==15)
    { fprintf(out,"%s",token); }
      else
    if (tokentype==5)
    { fprintf(out,"\n"); }
      else
    if (tokentype==6)
    { 
      putc('?',out);
      putc('>',out);
      if (copyhtml()==1) return 0;
      continue;
    }
      else
    if (tokentype==11)
    { eval_token(tokentype,token); }
      else
    { if (tokentype==2 || strcmp(token,"=")==0) eval_token(tokentype,token); }
  }

  return 1;
}

int main(int argc, char *argv[])
{
int t,tokentype,ch,lastchar;
char token[TOKENSIZE];
char temp[TOKENSIZE];
char infile[2048];
char outfile[2048];
int supress=0;


  if (argc<2)
  {
    printf("Usage: asp2php <infile.asp> -o <output filename>\n");
    printf("          -mysql -odbc -oracle   (to select database)\n");
    printf("          -uid <database username>\n");
    printf("          -passwd <database password>\n");
    printf("          -database <database name or sid>\n");
    printf("          -address <database ip address or ip name>\n");
    printf("          -dsn <database ODBC dsn>\n");
    printf("          -pngs (for Unipiss mode [read docs])\n");
    exit(1);
  }

  strcpy(infile,argv[1]);
  strcpy(outfile,infile);

  global_uid[0]=0;
  global_passwd[0]=0;
  global_dsn[0]=0;
  global_database[0]=0;
  global_address[0]=0;

  t=strlen(outfile);
  while (outfile[t]!='.' && t>0) t--;
  if (t!=0) outfile[t]=0;
  strcat(outfile,".php3"); 

  for(t=2; t<argc; t++)
  {
    if (strcasecmp(argv[t],"-o")==0)
    { strcpy(outfile,argv[++t]); }
      else
    if (strcasecmp(argv[t],"-mysql")==0)
    { database_type=0; }
      else
    if (strcasecmp(argv[t],"-odbc")==0)
    { database_type=1; }
      else
    if (strcasecmp(argv[t],"-oracle")==0)
    { database_type=2; }
      else
    if (strcasecmp(argv[t],"-uid")==0)
    { strcpy(global_uid,argv[++t]); }
      else
    if (strcasecmp(argv[t],"-passwd")==0)
    { strcpy(global_passwd,argv[++t]); }
      else
    if (strcasecmp(argv[t],"-database")==0)
    { strcpy(global_database,argv[++t]); }
      else
    if (strcasecmp(argv[t],"-address")==0)
    { strcpy(global_address,argv[++t]); }
      else
    if (strcasecmp(argv[t],"-dsn")==0)
    { strcpy(global_dsn,argv[++t]); }
      else
    if (strcasecmp(argv[t],"-supress")==0)
    { supress=1; }
      else
    if (strcasecmp(argv[t],"-pngs")==0)
    { pngs=1; }
  }

  if (supress==0)
  {
    printf("-----------------------------------------------------\n");
    printf("asp2php 0.73.1 - December 2, 1999\n");
    printf("Copyright 1999 By Michael Kohn (naken@i1.net)\n");
    printf("This is free for commercial and non-commercial use.\n");
    printf("THIS IS NOT GPL!  Please read the license!\n");
    printf("If you would like to contribute something (money,\n");
    printf("postcards, non-poisoned candy, hardware, a nice girl, etc)\n");
    printf("You can send me stuff at:\n\n");
    printf("Michael Kohn\n");
    printf("P.O. Box 6546\n");
    printf("Chesterfield, MO 63006-6546, USA\n");
    printf("For more info:  http://home.i1.net/~naken/asp2php/\n");
    printf("-----------------------------------------------------\n\n");
  }

  in=fopen(infile,"r");
  if (in==NULL)
  { printf("Error reading file: %s\n",infile); exit(1); }

  out=fopen(outfile,"w");
  if (out==NULL)
  { printf("Error opening output file: %s\n",outfile); exit(1); }

  printf("Opening file: %s\n",infile);
  printf("Creating file: %s\n\n",outfile);

  if (pngs==1)
  { printf("Unipiss mode: convert all gifs to pngs\n\n"); }

  while((ch=getc(in))!=EOF)
  {
    if (lastchar=='<' && ch=='%')
    {
      while((tokentype=gettoken(token))!=0)
      {
	if (tokentype==6) break;
	if (strcasecmp(token,"isnumeric")==0) add_isnum=1;
	if (strcasecmp(token,"bof")==0) BOF=1;
	if (strcasecmp(token,"Function")==0)
	{
	  tokentype=gettoken(token);
	  strcpy(funct[functptr++],token);
	}
	  else
	if (strcasecmp(token,"Sub")==0)
	{
	  tokentype=gettoken(token);
	  strcpy(funct[functptr++],token);
	}

	if (strcasecmp(token,"session")==0) 
	{
	  add_session=1;
	  tokentype=gettoken(token);
	  if (strcmp(token,"(")==0)
	  {
	    tokentype=gettoken(token);

	    if (tokentype==10 || tokentype==11)
	    {
	      t=gettoken(temp);

	      if (strcmp(temp,")")==0)
	      {
                for (t=0; t<sessionptr; t++)
                {
                  if (strcmp(token,sessionpool[t])==0) break;
                }
              }
                else
              { t=0; }

              if (sessionptr==t)
              {
                strcpy(sessionpool[sessionptr++],token);
              }
            }
	  }
	}
      }
    }
    lastchar=ch;
  }

  fclose(in);

  for (t=0; t<80; t++)
  { objects[t][0]=0; }

  in=fopen(infile,"r");
  if (in==NULL)
  { printf("Error reading file: %s\n",infile); exit(1); }

  if (add_session==1) insert_session();

  line=1;

  if (parse()==1)
  { printf("Parse Error occurred\n"); }
  putc('\n',out);

  printf("Done.\n");

  fclose(in);
  fclose(out);

  return 0;
}

