#include "globals.h"
#include "functions.h"


/* getvar() - grab the variables from the DSN string */

int getvar(char *answer, char *token, char *variable)
{
int t=0;
char *needle;

  needle=strcasestr(token,variable);
  answer[0]=0;

  if (needle==0)
  { return; }
    else
  {
    while (needle[0]!='=' && needle[0]!=0) needle++;

    if (needle[0]==0)
    { return; }

    needle++;
     
    if (needle[0]==0)
    { return; }

    while ((needle[t]!=';' && needle[t]!=0) &&
           (needle[t]!='\'' && needle[t]!='\"'))
    { t++; }
 
    strncpy(answer,needle,t);
    answer[t]=0;
  }
}

int db_open(char *newtoken,char *variable)
{
int tokentype;
char token[TOKENSIZE];
int paren=0,r;
char UID[TOKENSIZE];
char passwd[TOKENSIZE];
char database[TOKENSIZE];
char address[TOKENSIZE];
char dsn[TOKENSIZE];
char temp[LINELENGTH];

  tokentype=gettoken(token);
  if (strcmp(token,"(")==0)
  {
    paren=1;
    tokentype=gettoken(token);
  }

  if (global_uid[0]==0) { getvar(UID,token,"uid"); }
    else { strcpy(UID,global_uid); }
  if (global_passwd[0]==0) { getvar(passwd,token,"pwd"); }
    else { strcpy(passwd,global_passwd); }
  if (global_dsn[0]==0) { getvar(dsn,token,"dsn"); }
    else { strcpy(dsn,global_dsn); }
  if (global_database[0]==0) { getvar(database,token,"database"); }
    else { strcpy(database,global_database); }
  if (global_address[0]==0) { strcpy(address,"localhost"); }
    else { strcpy(address,global_address); }

  if (tokentype==10 || tokentype==11)
  {

    if (database_type==0)
    {
      sprintf(newtoken,"$%s=mysql_connect(\"%s\",\"%s\",\"%s\");\n",
                                       variable,address,UID,passwd);
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      sprintf(temp,"mysql_select_db(\"%s\",$%s);\n",database,variable); 
      strcat(newtoken,temp);
    }
      else
    if (database_type==1)
    {
      sprintf(newtoken,"$%s=odbc_connect(\"%s\",\"%s\",\"%s\");\n",
                                       variable,dsn,UID,passwd);
    }
      else
    if (database_type==2)
    {
      sprintf(newtoken,"$%s_conn=OCILogon(\"%s\",\"%s\");\n",
                                       variable,UID,passwd);
    }
  }
    else
  {
    push(token,tokentype);
    eval_molecule(temp);
    sprintf(newtoken,"$a2p_connstr=%s\n",temp);
    strcpy(temp,newtoken);

    strcat(temp,"$a2p_uid=strstr($a2p_connstr,'uid');\n");
    strcat(temp,"$a2p_uid=substr($d,strpos($d,'=')+1,strpos($d,';')-strpos($d,'=')-1);\n");

    strcat(temp,"$a2p_pwd=strstr($a2p_connstr,'pwd');\n");
    strcat(temp,"$a2p_pwd=substr($d,strpos($d,'=')+1,strpos($d,';')-strpos($d,'=')-1);\n");

    if (database_type==0)
    {
/*
      strcat(temp,"$a2p_database=strstr($a2p_connstr,'database');\n");
      strcat(temp,"$a2p_database=substr($d,strpos($d,'=')+1,strpos($d,';')-strpos($d,'=')-1);\n");
*/

      sprintf(newtoken,"%s$%s=mysql_connect(\"%s\",$a2p_uid,$a2p_pwd);\n",
                                       temp,variable,address);
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      /* sprintf(temp,"mysql_select_db($a2p_database,$%s);\n",variable);  */
      sprintf(temp,"mysql_select_db(\"%s\",$%s);\n",database,variable); 
      strcat(newtoken,temp);
    }
      else
    if (database_type==1)
    {
      strcat(temp,"$a2p_dsn=strstr($a2p_connstr,'dsn');\n");
      strcat(temp,"$a2p_dsn=substr($d,strpos($d,'=')+1,strpos($d,';')-strpos($d,'=')-1);\n");

      sprintf(newtoken,"%s$%s=odbc_connect($a2p_dsn,$a2p_uid,$a2p_pwd);\n",
                                       temp,variable);
    }
      else
    if (database_type==2)
    { sprintf(newtoken,"%s$%s_conn=OCILogon($a2p_uid,$a2p_pwd);\n",
                                       temp,variable); }
  }
 
  if (paren==1)
  { tokentype=gettoken(token); } 
}

int db_execute(char *newtoken,char *variable)
{
char molecule1[LINELENGTH];
char temp[TOKENSIZE];
char spaces[100];
int r;

  spaces[0]=0;
  eval_molecule(molecule1);

  if (setvar==0)
  {
    if (database_type==0)
    { sprintf(newtoken,"mysql_query(%s,$%s);",molecule1,variable); }
      else
    if (database_type==1)
    { sprintf(newtoken,"odbc_exec($%s,%s);",variable,molecule1); }
      else
    if (database_type==2)
    {
      sprintf(newtoken,"$%s_cursor=OCIParse($%s_conn,%s);\n",variable,variable,molecule1);
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      sprintf(temp,"$%s=OCIExecute($%s_cursor);\n",variable,variable);
      strcat(newtoken,temp);
    }
  }
    else
  {
    if (database_type==0)
    { sprintf(newtoken,"$%s_query=mysql_query(%s,$%s);",objects[setvar],molecule1,variable); }
      else
    if (database_type==1)
    {
      sprintf(newtoken,"$%s_query=odbc_exec($%s,%s);\n",objects[setvar],variable,molecule1);
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      sprintf(temp,"$%s_ptr=1;",objects[setvar]);
      strcat(newtoken,temp);
    }
      else
    if (database_type==2)
    {
      for (r=0; r<indent; r++)
      { strcat(spaces,"  "); }
      sprintf(newtoken,"$%s_cursor=OCIParse($%s_conn,%s);\n",objects[setvar],variable,molecule1);
      strcat(newtoken,spaces);
      sprintf(temp,"$%s=OCIExecute($%s_cursor);\n",objects[setvar],objects[setvar]);
      strcat(newtoken,temp);
    }

    if (BOF==1)
    {
      strcat(newtoken,"\n");
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      strcat(newtoken,"$");
      strcat(newtoken,objects[setvar]);
      strcat(newtoken,"_BOF=1;");
    }

    for (r=0; r<indent; r++)
    { strcat(newtoken,"  "); }

    strcpy(objectstype[setvar],"ADODB.Execute");

    if (database_type==0)
    { sprintf(molecule1,"\n$%s=mysql_fetch_array($%s_query);\n",objects[setvar],objects[setvar]); }
      else
    if (database_type==1)
    { sprintf(molecule1,"\n$%s=odbc_fetch_row($%s_query,$%s_ptr++);\n",objects[setvar],objects[setvar],objects[setvar]); }
      else
    if (database_type==2)
    { sprintf(molecule1,"\n$%s=OCIFetch($%s_cursor);\n",objects[setvar],objects[setvar]); }

    strcat(newtoken,molecule1);
  }
}

int parse_adodb_rs(char *newtoken,char *variable)
{
int tokentype;
char token[TOKENSIZE];
char molecule1[LINELENGTH];
char temp[512];
int r;

  autoindent();
  tokentype=gettoken(token);

  if (strcasecmp(token,"open")==0)
  {
    tokentype=gettoken(token);
  
    if (database_type==0)
    { 
      sprintf(newtoken,"mysql_query($%s_CommandText,$%s_ActiveConnection);",variable,variable); 
    }
      else
    if (database_type==1)
    { 
      sprintf(newtoken,"odbc_exec($%s_ActiveConnection,$%s_CommandText);",variable,variable); 
    }
      else
    if (database_type==2)
    {
      sprintf(newtoken,"$%s_cursor=OCIParse($%s_ActiveConnection,$%s_CommandText);\n",variable,variable,variable);
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      sprintf(temp,"$%s=OCIExecute($%s_cursor);\n",variable,variable);
      strcat(newtoken,temp);
    }
/*
    if (BOF==1)
    {
      strcat(newtoken,"\n");
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      strcat(newtoken,"$");
      strcat(newtoken,objects[setvar]);
      strcat(newtoken,"_BOF=1;");
    }
*/
  }
    else
  if (strcasecmp(token,"bof")==0)
  { sprintf(newtoken,"($%s_BOF==1)",variable); }
    else
  if (strcasecmp(token,"eof")==0)
  { sprintf(newtoken,"($%s==0)",variable); }
    else
  if (strcasecmp(token,"move")==0)
  {
    tokentype=gettoken(token);
    if (strcmp(token,"(")!=0)
    { error(token,"(","move"); }

    tokentype=gettoken(token);
    if (database_type==0)
    { sprintf(newtoken,"mysql_data_seek($%s_query,%s);\n",variable,token); }
      else
    if (database_type==1)
    { sprintf(newtoken,"odbc_fetch_row($%s_query,$%s_ptr=%s);\n",variable,objects[setvar],token); }

    tokentype=gettoken(token);
    if (strcmp(token,")")!=0)
    { error(token,")","move"); }
  }
    else
  if (strcasecmp(token,"count")==0 || strcasecmp(token,"recordcount")==0)
  {
    if (database_type==0)
    { sprintf(newtoken,"mysql_num_rows($%s_query)",variable); }
      else
    if (database_type==1)
    { sprintf(newtoken,"odbc_num_rows($%s_query)",variable); }
      else
    if (database_type==2)
    { sprintf(newtoken,"OCINumRows($%s)",variable); }
  }
    else
  if (strcasecmp(token,"movelast")==0)
  {
    if (database_type==0)
    {
      sprintf(newtoken,"mysql_data_seek($%s_query,mysql_num_rows($%s_query)-1);\n",variable,variable);
      sprintf(temp,"\n$%s=mysql_fetch_array($%s_query);\n",variable,variable);
      strcat(newtoken,temp);
    }
      else
    if (database_type==1)
    {
      sprintf(newtoken,"odbc_fetch_row($%s_query,$%s=odbc_num_rows($%s_query));\n",variable,variable,variable);
    }

    if (BOF==1)
    {
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      strcat(newtoken,"$");
      strcat(newtoken,variable);
      strcat(newtoken,"_BOF=0;\n");
    }
  }
    else
  if (strcasecmp(token,"movenext")==0)
  { 
    if (database_type==0)
    { sprintf(newtoken,"$%s=mysql_fetch_array($%s_query);\n",variable,variable); }
      else
    if (database_type==1)
    { sprintf(newtoken,"$%s=odbc_fetch_row($%s_query,$%s_ptr++);\n",variable,variable,variable); }
      else
    if (database_type==2)
    { sprintf(newtoken,"$%s=OCIFetch($%s_cursor);\n",variable,variable); }

    if (BOF==1)
    {
      for (r=0; r<indent; r++)
      { strcat(newtoken,"  "); }
      strcat(newtoken,"$");
      strcat(newtoken,variable);
      strcat(newtoken,"_BOF=0;\n");
    }
  }
    else
  if (strcmp(token,"(")==0)
  {
    tokentypepush=12;
    strcpy(tokenpush,"("); 
    molecule1[0]=0;
    eval_funct(molecule1);
    
    if (database_type==0)
    { sprintf(newtoken,"$%s[%s]",variable,molecule1); }
      else
    if (database_type==1)
    { sprintf(newtoken,"odbc_result($%s_query,%s)",variable,molecule1); }
      else
    if (database_type==2)
    {
      if (isnum(molecule1))
      { sprintf(newtoken,"OCIResult($%s_cursor,%s)",variable,molecule1); } 
	else
      { sprintf(newtoken,"OCIResult($%s_cursor,strtoupper(%s))",variable,molecule1); } 
    }

    tokentype=gettoken(token);
    if (strcmp(token,"=")==0)
    {
      fprintf(out,"%s=",newtoken);
      strcpy(newtoken,"");
      eval_expression(" ");
    }
      else
    { push(token,tokentype); }
  }
}

int parse_adodb_connection(char *newtoken,char *variable)
{
int tokentype;
char token[TOKENSIZE];

  tokentype=gettoken(token);

  if (strcasecmp(token,"open")==0)
  { db_open(newtoken,variable); } 
    else 
  if (strcasecmp(token,"execute")==0)
  { db_execute(newtoken,variable); }
    else
  if (strcasecmp(token,"close")==0)
  {
    if (database_type==0)
    { sprintf(newtoken,"mysql_close($%s)",variable); }
      else
    if (database_type==1)
    { sprintf(newtoken,"odbc_close($%s)",variable); }
      else
    if (database_type==2)
    { sprintf(newtoken,"// OCIClose($%s_cursor)",variable); }
    /* { sprintf(newtoken,"oracle_close($%s_cursor)",variable); } */
  }
}

